# invest

This entrypoint is designed to add liquidity to a specific DEX pool.

This method includes a balanced and imbalanced ways of investing.

### Call parameters

<table><thead><tr><th width="158">Field</th><th width="240" align="center">Type</th><th width="448.2">Description</th></tr></thead><tbody><tr><td>pool_id</td><td align="center"><code>nat</code></td><td>pool identifier</td></tr><tr><td>shares</td><td align="center"><code>nat</code></td><td>the minimal amount of shares to receive</td></tr><tr><td>in_amounts</td><td align="center"><code>map(token_pool_idx_t, nat)</code></td><td>map of token amounts to be invested</td></tr><tr><td>deadline</td><td align="center"><code>timestamp</code></td><td>dealine of current operation</td></tr><tr><td>receiver</td><td align="center"><code>option(address)</code></td><td>optional, address of the receiver of the LP tokens. If not provided the <code>sender</code> address will be used.</td></tr><tr><td>referral</td><td align="center"><code>option(address)</code></td><td>optional, address of the referral of the current operation. If not provided the <code>default_referral</code> address will be used.</td></tr></tbody></table>

```pascaligo
type invest_param_t     is [@layout:comb] record [
  pool_id                 : nat; 
  shares                  : nat; 
  in_amounts              : map(token_pool_idx_t, nat); 
  deadline                : timestamp; 
  receiver                : option(address); 
  referral                : option(address);
]
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.quipuswap.com/smart-contracts/quipuswap-stable-swap-dex/standalone-dex/dex-methods/invest.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
